package com.netease.flutter_hubble_track;

import com.netease.mobidroid.DATracker;

import java.util.Map;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;

/**
 * FlutterHubbleTrackPlugin
 */
public class FlutterHubbleTrackPlugin implements MethodCallHandler {
    /**
     * Plugin registration.
     */
    public static void registerWith(Registrar registrar) {
        final MethodChannel channel = new MethodChannel(registrar.messenger(),
                "flutter_hubble_track");
        channel.setMethodCallHandler(new FlutterHubbleTrackPlugin());
    }

    @Override
    public void onMethodCall(MethodCall call, Result result) {
        if (call.method.equals("track")) {
            onTrack(call);
        } else if (call.method.equals("upload")) {
            onUpload();
        } else if (call.method.equals("loginUser")) {
            onLoginUser(call);
        } else if (call.method.equals("logoutUser")) {
            onLogoutUser();
        } else if (call.method.equals("setLocation")) {
            onSetLocation(call);
        } else if (call.method.equals("trackTimer")) {
            onTrackTimer(call);
        } else {
            result.notImplemented();
            return;
        }
        result.success(null);
    }

    private void onTrack(MethodCall call) {
        String eventId = call.argument("eventId");
        Map<String, String> map = call.argument("attr");
        DATracker.getInstance().trackEvent(eventId, map);
    }

    private void onUpload() {
        DATracker.getInstance().upload();
    }

    private void onLoginUser(MethodCall call) {
        String userId = call.argument("userId");
        DATracker.getInstance().loginUser(userId);
    }

    private void onLogoutUser() {
        DATracker.getInstance().logoutUser();
    }

    private void onSetLocation(MethodCall call) {
        double latitude = call.argument("latitude");
        double longitude = call.argument("longitude");
        DATracker.getInstance().setLocation(latitude, longitude);
    }

    private void onTrackTimer(MethodCall call) {
        String eventId = call.argument("eventId");
        DATracker.getInstance().trackTimer(eventId);
    }
}
