#import "FlutterHubbleTrackPlugin.h"
#import <NEMobilytics/DATracker.h>

@implementation FlutterHubbleTrackPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"flutter_hubble_track"
            binaryMessenger:[registrar messenger]];
  FlutterHubbleTrackPlugin* instance = [[FlutterHubbleTrackPlugin alloc] init];
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    [self methodName:call.method andArguments:call.arguments];
    result(nil);
}

-(void)methodName:(NSString *)methodName andArguments:(id)arguments{
    if (![arguments isKindOfClass:[NSDictionary class]]) {
        return ;
    }
    NSDictionary *argDic = arguments ;
    if ([methodName isEqualToString:@"track"]) {
        NSString *eventID = argDic[@"eventId"];
        NSDictionary *attr = argDic[@"attr"];
        [[DATracker sharedTracker] trackEvent:eventID withAttributes:attr];
    } else if ([methodName isEqualToString:@"upload"]) {
        [[DATracker sharedTracker] upload];
    } else if ([methodName isEqualToString:@"loginUser"]) {
        NSString *userId = argDic[@"userId"];
        [[DATracker sharedTracker] loginUser:userId];
    } else if ([methodName isEqualToString:@"logoutUser"]) {
        [[DATracker sharedTracker] logoutUser];
    } else if ([methodName isEqualToString:@"setLocation"]) {
        NSNumber *latitude = (NSNumber *)argDic[@"latitude"];
        NSNumber *longitude = (NSNumber *)argDic[@"longitude"];
        [[DATracker sharedTracker] setLocation:[latitude doubleValue] andLongitude:[longitude doubleValue]];
    } else if ([methodName isEqualToString:@"trackTimer"]) {
        NSString *eventID = argDic[@"eventId"];
        [[DATracker sharedTracker] trackTimer:eventID];
    }
}

@end
