import 'dart:async';

import 'package:flutter/services.dart';

class FlutterHubbleTrack {
  static const MethodChannel _channel =
      const MethodChannel('flutter_hubble_track');

  static Future<Null> track(String eventId, [Map<String, String> attr]) async {
    Map<String, dynamic> args = {"eventId": eventId};
    if (attr != null) {
      args['attr'] = attr;
    }
    return await _channel.invokeMethod("track", args);
  }

  static Future<Null> upload() async {
    return await _channel.invokeMethod("upload");
  }

  static Future<Null> loginUser(String userId) async {
    return await _channel.invokeMethod("loginUser", {"userId": userId});
  }

  static Future<Null> logoutUser() async {
    return await _channel.invokeMethod("logoutUser");
  }

  static Future<Null> setLocation(double latitude, double longitude) async {
    return await _channel.invokeMethod("setLocation",
        {"latitude": latitude, "longitude": longitude});
  }

  static Future<Null> trackTimer(String eventId) async {
    return await _channel.invokeMethod("trackTimer", {"eventId": eventId});
  }
}
